/**
 * Bundle of @devexpress/dx-react-chart-bootstrap4
 * Generated: 2018-12-07
 * Version: 1.9.1
 * License: https://js.devexpress.com/Licensing
 */

import classNames from 'classnames';
import { withPatchedProps, Chart, Palette, Legend, Title, ScatterSeries, Axis, ValueAxis, ArgumentAxis, Tooltip } from '@devexpress/dx-react-chart';
export { AreaSeries, BarSeries, LineSeries, PieSeries, SplineSeries } from '@devexpress/dx-react-chart';
import { withComponents } from '@devexpress/dx-react-core';
import { createPortal } from 'react-dom';
import { node, func, oneOfType, string, instanceOf, bool } from 'prop-types';
import { Popper } from 'react-popper';
import { createElement, PureComponent, createRef } from 'react';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var withClassName = function withClassName() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var setClassName = function setClassName(_ref) {
    var className = _ref.className,
        restProps = _objectWithoutProperties(_ref, ["className"]);

    return _objectSpread({
      className: classNames.apply(void 0, args.concat([className]))
    }, restProps);
  };

  return withPatchedProps(setClassName);
};

var Root = withClassName('dx-c-bs4-container')(Chart.Root);

var Label = withClassName('dx-c-bs4-fill-current-color', 'dx-c-bs4-label', 'text-muted')(Chart.Label);

var palette = ['#0070ff', '#d72e3d', '#249d3d', '#ffb90c', '#1698af', '#616a72'];

var ChartWithPalette = function ChartWithPalette(_ref) {
  var children = _ref.children,
      props = _objectWithoutProperties(_ref, ["children"]);

  return createElement(Chart, props, createElement(Palette, {
    scheme: palette
  }), children);
};

ChartWithPalette.components = Chart.components;
process.env.NODE_ENV !== "production" ? ChartWithPalette.propTypes = {
  children: node.isRequired
} : void 0;
var Chart$1 = withComponents({
  Root: Root
})(ChartWithPalette);
Chart$1.Label = Label;

var Root$1 = withClassName('list-group', 'py-3')(function (props) {
  return createElement("ul", props);
});

var Label$1 = withClassName('text-body', 'pl-2', 'pr-2')(function (_ref) {
  var text = _ref.text,
      restProps = _objectWithoutProperties(_ref, ["text"]);

  return createElement("span", restProps, text);
});

var Item = withClassName('d-flex', 'list-group-item', 'border-0', 'py-1', 'px-4', 'align-items-center')(function (props) {
  return createElement("li", props);
});

var Legend$1 = withComponents({
  Root: Root$1,
  Item: Item,
  Label: Label$1
})(Legend);

var Text = withClassName('w-100', 'text-center', 'mb-3')(function (_ref) {
  var text = _ref.text,
      restProps = _objectWithoutProperties(_ref, ["text"]);

  return createElement("h3", restProps, text);
});

var Title$1 = withComponents({
  Text: Text
})(Title);

var setClassName = function setClassName(_ref) {
  var classes = _ref.classes,
      restProps = _objectWithoutProperties(_ref, ["classes"]);

  if (restProps.state) {
    var className = restProps.className,
        rest = _objectWithoutProperties(restProps, ["className"]);

    return _objectSpread({
      className: classNames('dx-c-bs4-fill-background-color', className)
    }, rest);
  }

  return restProps;
};

var Point = withPatchedProps(setClassName)(ScatterSeries.Point);

var ScatterSeries$1 = withComponents({
  Point: Point
})(ScatterSeries);

var Root$2 = withClassName('dx-c-bs4-crisp-edges')(Axis.Root);

var Tick = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-crisp-edges', 'dx-c-bs4-axis-opacity')(Axis.Tick);

var Label$2 = withClassName('dx-c-bs4-fill-current-color', 'dx-c-bs4-label', 'text-muted')(Axis.Label);

var Line = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-axis-opacity')(Axis.Line);

var Grid = withClassName('dx-c-bs4-stroke-current-color', 'dx-c-bs4-crisp-edges', 'dx-c-bs4-axis-opacity')(Axis.Grid);

var ValueAxis$1 = withComponents({
  Root: Root$2,
  Tick: Tick,
  Label: Label$2,
  Line: Line,
  Grid: Grid
})(ValueAxis);

var ArgumentAxis$1 = withComponents({
  Root: Root$2,
  Tick: Tick,
  Label: Label$2,
  Line: Line,
  Grid: Grid
})(ArgumentAxis);

var Popover =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Popover, _React$PureComponent);

  function Popover(props) {
    var _this;

    _classCallCheck(this, Popover);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Popover).call(this, props));
    _this.contentRef = createRef();
    _this.handleClick = _this.handleClick.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(Popover, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.toggleSubscribtions();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.toggleSubscribtions();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.detachDocumentEvents();
    }
  }, {
    key: "handleClick",
    value: function handleClick(e) {
      var eventTarget = e.target;
      var contentNode = this.contentRef.current;
      var _this$props = this.props,
          toggle = _this$props.toggle,
          target = _this$props.target;

      if (contentNode && !contentNode.contains(eventTarget) && !target.contains(eventTarget)) {
        toggle();
      }
    }
  }, {
    key: "toggleSubscribtions",
    value: function toggleSubscribtions() {
      var isOpen = this.props.isOpen;

      if (isOpen) {
        this.attachDocumentEvents();
      } else {
        this.detachDocumentEvents();
      }
    }
  }, {
    key: "attachDocumentEvents",
    value: function attachDocumentEvents() {
      this.toggleDocumentEvents('addEventListener');
    }
  }, {
    key: "detachDocumentEvents",
    value: function detachDocumentEvents() {
      this.toggleDocumentEvents('removeEventListener');
    }
  }, {
    key: "toggleDocumentEvents",
    value: function toggleDocumentEvents(method) {
      var _this2 = this;

      ['click', 'touchstart'].forEach(function (eventType) {
        document[method](eventType, _this2.handleClick, true);
      });
    }
  }, {
    key: "renderPopper",
    value: function renderPopper() {
      var _this3 = this;

      var _this$props2 = this.props,
          children = _this$props2.children,
          target = _this$props2.target,
          restProps = _objectWithoutProperties(_this$props2, ["children", "target"]);

      return createElement(Popper, _extends({
        referenceElement: target
      }, restProps), function (_ref) {
        var ref = _ref.ref,
            style = _ref.style,
            arrowProps = _ref.arrowProps,
            placement = _ref.placement;
        return createElement("div", {
          className: "popover show bs-popover-".concat(placement),
          ref: ref,
          style: style
        }, createElement("div", {
          className: "popover-inner",
          ref: _this3.contentRef
        }, children), createElement("div", {
          className: "arrow",
          ref: arrowProps.ref,
          style: arrowProps.style
        }));
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          isOpen = _this$props3.isOpen,
          container = _this$props3.container;
      if (!isOpen) return null;
      return container === 'body' ? createPortal(this.renderPopper(), document.body) : this.renderPopper();
    }
  }]);

  return Popover;
}(PureComponent);
var targetElementType = oneOfType([string, func, node, instanceOf(typeof Element !== 'undefined' ? Element : Object)]);
process.env.NODE_ENV !== "production" ? Popover.propTypes = {
  container: targetElementType,
  placement: string,
  isOpen: bool,
  children: node.isRequired,
  target: targetElementType,
  toggle: func
} : void 0;
Popover.defaultProps = {
  target: null,
  container: 'body',
  isOpen: false,
  placement: 'auto',
  toggle: function toggle() {}
};

// For the first time it returns null as expected and Popover crashes.
// Because of it the following HOC is used to unwrap DOM element from *target* function.

var Overlay =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Overlay, _React$PureComponent);

  function Overlay() {
    _classCallCheck(this, Overlay);

    return _possibleConstructorReturn(this, _getPrototypeOf(Overlay).apply(this, arguments));
  }

  _createClass(Overlay, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.forceUpdate();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          target = _this$props.target,
          restProps = _objectWithoutProperties(_this$props, ["children", "target"]);

      var domElement = target();
      return domElement ? createElement(Popover, _extends({
        placement: "top",
        isOpen: true,
        target: domElement
      }, restProps), createElement("div", {
        className: "popover-body"
      }, children)) : null;
    }
  }]);

  return Overlay;
}(PureComponent);
process.env.NODE_ENV !== "production" ? Overlay.propTypes = {
  children: node.isRequired,
  target: func.isRequired
} : void 0;

var Content = function Content(_ref) {
  var text = _ref.text,
      targetItem = _ref.targetItem,
      restProps = _objectWithoutProperties(_ref, ["text", "targetItem"]);

  return createElement("span", restProps, text);
};

var Tooltip$1 = withComponents({
  Overlay: Overlay,
  Content: Content
})(Tooltip);

export { Chart$1 as Chart, Legend$1 as Legend, Title$1 as Title, ScatterSeries$1 as ScatterSeries, ValueAxis$1 as ValueAxis, ArgumentAxis$1 as ArgumentAxis, Tooltip$1 as Tooltip };
//# sourceMappingURL=dx-react-chart-bootstrap4.es.js.map
